function [x,y,typ]=JS_BUTTONS_f(job,arg1,arg2)
//
// $Id: JS_BUTTONS_f.sci,v 1.3 2002/04/30 12:33:44 dirk Exp $
// Copyright (C) 2002 by Dirk Reusch <reusch@tmb.uka.de>
//
x=[];y=[];typ=[]
select job
case 'plot' then
  standard_draw(arg1)
case 'getinputs' then
  [x,y,typ]=standard_inputs(arg1)
case 'getoutputs' then
  [x,y,typ]=standard_outputs(arg1)
case 'getorigin' then
  [x,y]=standard_origin(arg1)
case 'set' then

  x=arg1;model=x.model;
  graphics=arg1.graphics;exprs=graphics.exprs
  out=model.out
  ipar=model.ipar

  while %t do
    [ok,dev,buttons]=getvalue(...
	'Set JS_BUTTONS block parameters',...
	['Joystick Device';
	'Button'],...
	list('vec',1,'str',1),exprs);
    if ~ok then break,end //user cancel modification
    
    msg=[];
    dev=int(dev);
    if (dev<0) then
      msg=[msg;'- Joystick device has to be >= 0';' '];
      ok=%f;
    end
    
    [buttons,ierr]=evstr(buttons);
    if ierr then
      msg=[msg;'- Buttons are specified by a vector of integers';' '];
      nbuttons=0;
      ok=%f;
    else
      nbuttons=length(buttons);
      if nbuttons<0 then
        msg=[msg;'- At least 1 button has to be specified';' '];
        ok=%f;
      end
    end

    if ~ok then
      x_message(['Some specified values are inconsistent:';' ';msg]);
    else
	  ipar=[]
      ipar(1)=dev
      for i=1:nbuttons do
        ipar(1+i)=buttons(i)
      end
	  model.ipar=ipar
	  model.out=nbuttons
	  graphics.exprs=[string(dev);sci2exp(buttons)]
	  x.graphics=graphics;x.model=model
      break
    end
  end
case 'define' then
  dev=0;
  buttons=[0];
  ipar=[dev,buttons]
  
  model=scicos_model()
  model.sim=list('sci_js_buttons',2)
  model.out=length(buttons)
  model.evtin=1
  model.evtout=[]
  model.dstate=[]
  model.ipar=ipar
  model.blocktype='d'
  model.firing=[]
  model.dep_ut=[%f %f]

  exprs=[string(dev);sci2exp(buttons)]
  gr_i=['ipar=model.ipar;dev=ipar(1)';
      'nbuttons=length(ipar)-1;buttons=ipar(2:1+nbuttons)';
      'txt=[''/dev/js''+string(dev)]';
      'xstringb(orig(1),orig(2)+0.75*sz(2),txt,sz(1),sz(2)/4,''fill'')';
      'xstringb(orig(1),orig(2)+0.25*sz(2),''Button'',sz(1),sz(2)/2,''fill'')';
      'xstringb(orig(1),orig(2),sci2exp(buttons),sz(1),sz(2)/4,''fill'')']
  x=standard_define([3 2],model,exprs,gr_i)
end
endfunction

